unit adsy;
{Adaptives System Version 1.0
 Angefangen:9.7.1999
}

interface

const
  MAXINEU=16;
  MAXZNEU=16;{Breite der Schicht}
  MAXNNEU=4; {Anzahl der Schichten}
  MAXANEU=8;
  MAXINPUT=16;
  STATFACT=0.99;

type
  neuron=record
    w,dw,dsw:array[1..MAXINPUT] of real;
    a,net,theta,dtheta,dstheta:real;
    delta:real;{neu}
  end;
  netz=record
         inputs:array[1..MAXINEU] of real;{Pseudo-Neuronen als Eingabe-Neuronen}
         zneu  :array[1..MAXZNEU,1..MAXNNEU] of neuron;
         aneu  :array[1..MAXANEU] of neuron;
         inum,znum,nnum,anum:word;
         gerechnet:boolean;
         lastimp:real;
       end;

procedure   initnet(var nn:netz;inputnum,xsize,ysize,ausgaenge:word);
procedure   input(var nn:netz;num:word;value:real);
function    output(var nn:netz;num:word):real;
function    getinput(var nn:netz;num:word):real;
procedure   rechnen(var nn:netz);
procedure   lernsoll(var nn:netz;ausgang:word;soll:real;eta,alpha:real);
procedure   lernstat(var nn:netz;impuls,eta:real);
procedure   loadnetz(var nn:netz;fname:string);
procedure   savenetz(var nn:netz;fname:string);

implementation

uses crt,dos;

procedure initnet(var nn:netz;inputnum,xsize,ysize,ausgaenge:word);
var i,j,p:word;
begin
  with nn do begin
    {Allokieren und initialisieren}
    inum:=inputnum;
    znum:=xsize;
    nnum:=ysize;
    anum:=ausgaenge;
    gerechnet:=false;
    for i:=1 to inum do begin
      inputs[i]:=0;
    end;
    for i:=1 to znum do begin
      for j:=1 to nnum do begin
        if j=1 then
          for p:=1 to inputnum do begin
            zneu[i,j].w[p]:=random(2000)/1000-1;
            zneu[i,j].dw[p]:=0;
            zneu[i,j].dsw[p]:=1;
          end
        else
          for p:=1 to znum do begin
            zneu[i,j].w[p]:=random(2000)/1000-1;
            zneu[i,j].dw[p]:=0;
            zneu[i,j].dsw[p]:=1;
          end;
        zneu[i,j].theta:=random(2000)/1000-1;
        zneu[i,j].dtheta:=0;
        zneu[i,j].dstheta:=1;
      end;
    end;
    for i:=1 to anum do begin
      for p:=1 to znum do begin
         aneu[i].w[p]:=random(2000)/1000-1;
         aneu[i].dw[p]:=0;
         aneu[i].dsw[p]:=1;
      end;
      aneu[i].theta:=random(2000)/1000-1;
      aneu[i].dtheta:=0;
      aneu[i].dstheta:=1;
    end;
  end;
end;

procedure loadnetz(var nn:netz;fname:string);
var f:file of netz;
begin
  assign(f,fname);
  reset(f);
  read(f,nn);
  close(f);
end;

procedure savenetz(var nn:netz;fname:string);
var f:file of netz;
begin
  assign(f,fname);
  rewrite(f);
  write(f,nn);
  close(f);
end;

procedure input(var nn:netz;num:word;value:real);
begin
  with nn do begin
    gerechnet:=false;
    inputs[num]:=value;
  end;
end;

function output(var nn:netz;num:word):real;
begin
  with nn do begin
    if not gerechnet then rechnen(nn);
    output:=aneu[num].a;
  end;
end;

function getinput(var nn:netz;num:word):real;
begin
  with nn do begin
    getinput:=inputs[num];
  end;
end;

procedure rechnen(var nn:netz);
var i,j,p:word;
begin
  with nn do begin
    for j:=1 to nnum do begin
      for i:=1 to znum do begin
        zneu[i,j].net:=0;
        if j=1 then
          for p:=1 to inum do begin
            zneu[i,j].net:=zneu[i,j].net+zneu[i,j].w[p]*inputs[p];
          end
        else
          for p:=1 to znum do begin
            zneu[i,j].net:=zneu[i,j].net+zneu[i,j].w[p]*zneu[p,j-1].a;
          end;
        zneu[i,j].net:=zneu[i,j].net+zneu[i,j].theta;
        zneu[i,j].a:=1/(1+exp(-zneu[i,j].net));
                     {(sin(zneu[i,j].net)+1)/2;}
      end;
    end;
    for i:=1 to anum do begin
      aneu[i].net:=0;
      for p:=1 to znum do begin
        aneu[i].net:=aneu[i].net+aneu[i].w[p]*zneu[p,nnum].a;
      end;
      aneu[i].net:=aneu[i].net+aneu[i].theta;
{      aneu[i].a:=1/(1+exp(-aneu[i].net));}
                 {(sin(aneu[i].net)+1)/2;}
      {if i=anum then} aneu[i].a:=aneu[i].net;
    end;
    gerechnet:=true;
  end;
end;

procedure lernstat(var nn:netz;impuls,eta:real);
var i,j,p:word;
begin
  with nn do begin
    for i:=1 to znum do begin
      for p:=1 to inum do begin
        zneu[i,1].dw[p]:=0.5*(impuls-lastimp)*zneu[i,1].dsw[p];
        zneu[i,1].dsw[p]:=STATFACT*zneu[i,1].dsw[p]+zneu[i,1].dw[p];
        zneu[i,1].w[p]:=zneu[i,1].w[p]+eta*zneu[i,1].dw[p];
      end;
      zneu[i,1].dtheta:=0.5*(impuls-lastimp)*zneu[i,1].dstheta;
      zneu[i,1].dstheta:=STATFACT*zneu[i,1].dstheta+zneu[i,1].dtheta;
      zneu[i,1].theta:=zneu[i,1].theta+eta*zneu[i,1].dtheta;
    end;
    if nnum>=2 then
      for i:=1 to znum do begin
        for j:=2 to nnum do begin
          for p:=1 to nnum do begin
            zneu[i,j].dw[p]:=0.5*(impuls-lastimp)*zneu[i,j].dsw[p];
            zneu[i,j].dsw[p]:=STATFACT*zneu[i,j].dsw[p]+zneu[i,j].dw[p];
            zneu[i,j].w[p]:=zneu[i,j].w[p]+eta*zneu[i,j].dw[p];
          end;
          zneu[i,j].dtheta:=0.5*(impuls-lastimp)*zneu[i,j].dstheta;
          zneu[i,j].dstheta:=STATFACT*zneu[i,j].dstheta+zneu[i,j].dtheta;
          zneu[i,j].theta:=zneu[i,j].theta+eta*zneu[i,j].dtheta;
        end;
      end;
    for i:=1 to anum do begin
      for p:=1 to znum do begin
        aneu[i].dw[p]:=0.5*(impuls-lastimp)*aneu[i].dsw[p];
        aneu[i].dsw[p]:=STATFACT*aneu[i].dsw[p]+aneu[i].dw[p];
        aneu[i].w[p]:=aneu[i].w[p]+eta*aneu[i].dw[p];
      end;
      aneu[i].dtheta:=aneu[i].dtheta+0.5*(impuls-lastimp)*aneu[i].dstheta;
      aneu[i].dstheta:=STATFACT*aneu[i].dstheta+aneu[i].dtheta;
      aneu[i].theta:=aneu[i].theta+eta*aneu[i].dtheta;
    end;
    lastimp:=impuls;
  end;
end;

procedure lernsoll(var nn:netz;ausgang:word;soll:real;eta,alpha:real);
var i,j,p:word;
    s:real;
begin
  with nn do begin
    if not gerechnet then rechnen(nn);
    for i:=1 to anum do aneu[i].delta:=0;
    aneu[ausgang].delta:=(soll-aneu[ausgang].a)*1/(1+exp(-aneu[ausgang].net))*(1-1/(1+exp(-aneu[ausgang].net)));
                                                {0.5*cos(aneu[ausgang].net);}
    {back-propagation}
    for j:=nnum downto 1 do begin
      for i:=1 to znum do begin
        s:=0;
        if j=nnum then
          for p:=1 to anum do begin
            s:=s+aneu[p].w[i]*aneu[p].delta;
          end
        else
          for p:=1 to znum do begin
            s:=s+zneu[p,j+1].w[i]*zneu[p,j+1].delta;
          end;
        zneu[i,j].delta:={0.5*cos(zneu[i,j].net)*s;}
                         1/(1+exp(-zneu[i,j].net))*(1-1/(1+exp(-zneu[i,j].net)))*s;
      end;
    end;
    {nderung der Gewichte}
    for j:=1 to nnum do begin
      for i:=1 to znum do begin
        if j=1 then
          for p:=1 to inum do begin
            zneu[i,j].dw[p]:=alpha*zneu[i,j].dw[p]+zneu[i,j].delta*inputs[p];
            zneu[i,j].dsw[p]:=STATFACT*zneu[i,j].dsw[p]+zneu[i,j].dw[p];
            zneu[i,j].w[p]:=zneu[i,j].w[p]+eta*zneu[i,j].dw[p];
          end
        else
          for p:=1 to znum do begin
            zneu[i,j].dw[p]:=alpha*zneu[i,j].dw[p]+zneu[i,j].delta*zneu[p,j-1].a;
            zneu[i,j].dsw[p]:=STATFACT*zneu[i,j].dsw[p]+zneu[i,j].dw[p];
            zneu[i,j].w[p]:=zneu[i,j].w[p]+eta*zneu[i,j].dw[p];
          end;
        zneu[i,j].dtheta:=alpha*zneu[i,j].dtheta+zneu[i,j].delta;
        zneu[i,j].dstheta:=STATFACT*zneu[i,j].dstheta+zneu[i,j].dtheta;
        zneu[i,j].theta:=zneu[i,j].theta+eta*zneu[i,j].dtheta;
      end;
    end;
    for i:=1 to anum do begin
      for p:=1 to znum do begin
        aneu[i].dw[p]:=alpha*aneu[i].dw[p]+aneu[i].delta*zneu[p,nnum].a;
        aneu[i].dsw[p]:=STATFACT*aneu[i].dsw[p]+aneu[i].dw[p];
        aneu[i].w[p]:=aneu[i].w[p]+eta*aneu[i].dw[p];
      end;
      aneu[i].dtheta:=alpha*aneu[i].dtheta+aneu[i].delta;
      aneu[i].dstheta:=STATFACT*aneu[i].dstheta+aneu[i].dtheta;
      aneu[i].theta:=aneu[i].theta+eta*aneu[i].dtheta;
    end;
    gerechnet:=false;
  end;
end;

begin
  randomize;
end.