unit newcrt;

interface

uses dos;{Fr BIOS- Aufrufe}

procedure clrscr;
procedure gotoxy(x,y:byte);
procedure delay(ms:word);
function keypressed:boolean;
function readkey:char;
function whereX:byte;
function whereY:byte;

implementation

var
  erw:boolean;{erweiterter ASCII-code}
  erwch:char;

procedure delay(ms:word);
var ml,mh:word;
begin
  mh:=longint(ms)*1000 div 65536;
  ml:=longint(ms)*1000-longint(mh)*65536;
  asm
    mov ah,86h
    mov cx,mh
    mov dx,ml
    int 15h
  end;
end;

procedure clrscr;{Bildschirm lschen}
var i:word;
begin
  asm
    mov ah,2h
    mov bh,0
    mov dh,0
    mov dl,0
    int 10h
  end;
  for i:=0 to 24 do write('                                                                                ');
  asm
    mov ah,2h
    mov bh,0
    mov dh,0
    mov dl,0
    int 10h
  end;
{  asm
    mov ah,06h
    mov al,0
    mov ch,0
    mov cl,0
    mov dh,49
    mov dl,79
    mov bh,0
    int 10h
  end;
  asm
    mov ah,2h
    mov bh,0
    mov dh,0
    mov dl,0
    int 10h
  end;}
end;

procedure gotoxy(x,y:byte);assembler;
asm
  mov ah,2h
  mov bh,0
  mov dh,y
  mov dl,x
  int 10h
end;

function keypressed:boolean;{Taste gedrckt?}
var Rg:Registers;
begin
  Rg.ah:=1;    {Unterfunktion 01}
  Intr($16,Rg);{des Interrupts 16h}
  if (Rg.flags and fZero)=0 then begin{Zero-Flag gesetzt?}
    {Zeichen vorhanden}
    keypressed:=true;
    exit;
  end;
  {kein Zeichen vorhanden}
  keypressed:=false;
end;

function readkey:char;
var Rg:Registers;
begin
  if not erw then begin{Ist erweiterter Tastencode vorhanden?}
    Rg.ah:=0;    {Unterfunktion 00}
    Intr($16,Rg);{des Interrupts 16h}
    if Rg.al<>0 then begin
      {Normaler ASCII-Code}
      readkey:=chr(Rg.al);
      exit;
    end else begin
      {Erweiterter ASCII-Code, 1. Aufruf von readkey}
      erw:=true;
      erwch:=chr(Rg.ah);
      readkey:=#0;
      exit;
    end;
  end else begin
    {erweiterter Tastencode, 2.aufruf von readkey}
    erw:=false;
    readkey:=erwch;
  end;
end;

function wherex:byte;
var x:byte;
begin
  asm
    mov ah,03h
    mov bh,0
    int 10h
    mov x,dl
  end;
  wherex:=x;
end;

function wherey:byte;
var y:byte;
begin
  asm
    mov ah,03h
    mov bh,0
    int 10h
    mov y,dh
  end;
  wherey:=y;
end;

begin{Unit-initialisierung}
  erw:=False;{kein erweiterter Tastaturcode vorhanden}
end.