program hetero_assoziatives_neuronales_Netz;

uses crt,dos,graph,ksgraph;

const
  INNUM=2;
  ZNUM=2;
  ANUM=1;
  MNUM=1;
  MAXIN=INNUM+ZNUM;
  BUCH_BEISPIEL=false;
  ZUFALL_WAHL=false;{Wahl der Eingabekonfiguration fr Lernschritt}
  ETA_=1.0;{Nur fr BUCH_BEISPIEL=false}
  ALPHA_=0.0;
  ALPHA_1000=true;{setzt Alpha nach 1000 Schritten auf 0.}

  {gute Konfigurationen:
   eta=0.6, alpha 0.0, alpha_1000 false
   eta=0.6, alpha 0.6, alpha_1000 false
   eta=1.0, alpha 0.6, alpha_1000 true
  }

type
  neuron=record
    input:array[1..MAXIN] of ^real;
    w,dw:array[1..MAXIN] of real;
    a,net,theta:real;
    delta:real;{neu}
  end;

var
  z:array[1..MNUM,1..ZNUM] of neuron;
  a:array[1..ANUM] of neuron;
  asoll:array[1..ANUM] of real;
  eta,alpha:real;
  input:array[0..INNUM] of real;
  erste:boolean;
  grx:longint;
  grf:array[0..15]of longint;
  grfa:array[0..15]of real;
  incount:longint;
  count:longint;
  fehler:real;

function fakt(x:real):real;
begin
{  fakt:=1/(1+exp(-x));}
{   fakt:=(1*arctan(x)+PI/2)/PI;}
{   fakt:=0.1*x;}
  fakt:=(sin(x)+1)/2;
end;

function dfakt(x:real):real;
begin
{  dfakt:=1/(1+exp(-x))*(1-1/(1+exp(-x)));}
{   dfakt:=0.01/x;}
{  if fakt(x)=1 then dfakt:=10;}
{  dfakt:=fakt(x)*(1-fakt(x));}
{   dfakt:=(1/(x*x+1))/PI;}
   dfakt:=cos(x);
end;

procedure lern(ausgang_id:word);{neu}
var i,j,k,m:word;
    s:real;
begin
  if ausgang_id<>0 then begin
    a[ausgang_id].delta:=(asoll[ausgang_id]-a[ausgang_id].a)*dfakt(a[ausgang_id].net);
    for j:=1 to ZNUM do begin
      s:=0;
      for k:=1 to ANUM do begin
        s:=s+a[k].delta*a[k].w[j];
      end;
      z[MNUM,j].delta:=dfakt(z[MNUM,j].net)*s;
    end;
    if MNUM>1 then
    for m:=MNUM-1 downto 1 do begin
      for j:=1 to ZNUM do begin
        s:=0;
        for k:=1 to ZNUM do begin
          s:=s+z[m+1,k].delta*z[m+1,k].w[j];
        end;
        z[m,j].delta:=dfakt(z[m,j].net)*s;
      end;
    end;
  end else begin
    for j:=1 to ANUM do begin
      a[j].delta:=(asoll[j]-a[j].a)*dfakt(a[j].net);
    end;
    for j:=1 to ZNUM do begin
      s:=0;
      for k:=1 to ANUM do begin
        s:=s+a[k].delta*a[k].w[j];
      end;
      z[MNUM,j].delta:=dfakt(z[MNUM,j].net)*s;
    end;
    if MNUM>1 then
    for m:=MNUM-1 downto 1 do begin
      for j:=1 to ZNUM do begin
        s:=0;
        for k:=1 to ZNUM do begin
          s:=s+z[m+1,k].delta*z[m+1,k].w[j];
        end;
        z[m,j].delta:=dfakt(z[m,j].net)*s;
      end;
    end;
  end;
  for j:=1 to ANUM do begin
    for i:=1 to ZNUM do begin
      a[j].dw[i]:=eta*a[j].delta*(a[j].input[i]^)+alpha*a[j].dw[i];
      a[j].w[i]:=a[j].w[i]+a[j].dw[i];
    end;
    a[j].theta:=a[j].theta+eta*a[j].delta;
  end;
  for m:=1 to MNUM do begin
    for j:=1 to ZNUM do begin
      for i:=1 to ZNUM do begin
        z[m,j].dw[i]:=eta*z[m,j].delta*(z[m,j].input[i]^)+alpha*z[m,j].dw[i];
        z[m,j].w[i]:=z[m,j].w[i]+z[m,j].dw[i];
      end;
      z[m,j].theta:=z[m,j].theta+eta*z[m,j].delta;
    end;
  end;
  inc(count);
  if (ALPHA_1000)and(count>=1000) then alpha:=0;
end;

procedure buildnet;
var m,i,j:word;
begin
  randomize;
  for j:=1 to ZNUM do begin
    for i:=1 to INNUM do begin
      z[1,j].input[i]:=@input[i];
      z[1,j].dw[i]:=0;
      z[1,j].w[i]:=random-0.5;
    end;
    z[1,j].theta:=random-0.5;
  end;
  for m:=2 to MNUM do begin
    for j:=1 to ZNUM do begin
      for i:=1 to ZNUM do begin
        z[m,j].input[i]:=@z[m-1,i].a;
        z[m,j].dw[i]:=0;
        z[m,j].w[i]:=random-0.5;
      end;
    end;
    z[m,j].theta:=random-0.5;
  end;
  for j:=1 to ANUM do begin
    for i:=1 to ZNUM do begin
      a[j].input[i]:=@z[MNUM,i].a;
      a[j].dw[i]:=0;
      a[j].w[i]:=random-0.5;
    end;
    a[j].theta:=random-0.5;
  end;
  eta:=ETA_;
  alpha:=ALPHA_;
  if BUCH_BEISPIEL then begin
    eta:=0.6;
    alpha:=0.9;
    z[1,1].w[1]:=0.46;
    z[1,2].w[1]:=-0.44;
    z[1,1].w[2]:=0.36;
    z[1,2].w[2]:=0.36;
    z[1,1].theta:=-0.4;
    z[1,2].theta:=0.01;
    a[1].w[1]:=0.18;
    a[1].w[2]:=-0.16;
    a[1].theta:=-0.37;
  end;
end;

procedure rechnen;
var i,j,m:word;
begin
  for j:=1 to ZNUM do begin
    z[1,j].net:=0;
    for i:=1 to INNUM do begin
      z[1,j].net:=z[1,j].net+z[1,j].w[i]*z[1,j].input[i]^;
    end;
    z[1,j].net:=z[1,j].net+z[1,j].theta;
    z[1,j].a:=fakt(z[1,j].net);
  end;
  for m:=2 to MNUM do begin
    for j:=1 to ZNUM do begin
      z[m,j].net:=0;
      for i:=1 to ZNUM do begin
        z[m,j].net:=z[m,j].net+z[m,j].w[i]*z[m,j].input[i]^;
      end;
      z[m,j].net:=z[m,j].net+z[m,j].theta;
      z[m,j].a:=fakt(z[m,j].net);
    end;
  end;
  for j:=1 to ANUM do begin
    a[j].net:=0;
    for i:=1 to ZNUM do begin
      a[j].net:=a[j].net+a[j].w[i]*a[j].input[i]^;
    end;
    a[j].net:=a[j].net+a[j].theta;
    a[j].a:=fakt(a[j].net);
  end;
end;

function pow2(n:longint):longint;
var r:longint;
    i:longint;
begin
  r:=1;
  if n>0 then
  for i:=1 to n do begin
    r:=r*2;
  end;
  pow2:=r;
end;

function setinputs:word;
var i,j,h,m,s,hs:word;
begin
  if (erste)and(BUCH_BEISPIEL) then begin
    for i:=1 to INNUM do begin
      input[i]:=0;
    end;
  end else begin
    if ZUFALL_WAHL then begin
      for i:=1 to INNUM do begin
        input[i]:=random(2);
      end;
    end else begin
      for i:=0 to pow2(INNUM) do begin
        if incount mod pow2(INNUM)=i then begin
          for j:=1 to INNUM do begin
            input[j]:=(i div pow2(j-1)) mod 2;
          end;
        end;
      end;
    end;
  end;
  inc(incount);
  setinputs:=0;{Ausgabe #, die korrigiert wird; 0 fr alle Ausgnge}
end;

procedure setasolls(n:word);{neu}
var i,j:word;
begin
  for i:=1 to ANUM do begin
    asoll[i]:=0;
    for j:=1 to INNUM do begin
      asoll[i]:=asoll[i]+input[j];
    end;
    asoll[i]:=round(asoll[i]) mod 2;
  end;
end;

procedure grafik(aus:word);
var col:longint;
    i:word;
begin
  col:=1;
  for i:=1 to INNUM do begin
    col:=col+trunc(input[i]*pow2(i));
    if i>10000 then break;
  end;
  setcolor(black);
  line(grx,300,grx,479);
  putpixel(grx,470,darkgray);
  setcolor(col);
  if not erste then line(grx,470-trunc(a[aus].a*170),grf[col],470-trunc(grfa[col]*170));
  inc(grx);
  grf[col]:=grx;
  grfa[col]:=a[aus].a;
  if grx>=640 then begin
    grx:=11;
    for i:=0 to 15 do grf[i]:=11;
  end;
end;

var
  ch:char;
  i,j,n:word;
begin
  startgraph;
  setcolor(darkgray);
  line(10,470,639,470);
  line(10,300,10,470);
  grx:=11;
  for i:=0 to 15 do begin
    grf[i]:=11;
    grfa[i]:=0.5;
  end;
  textcolor(white);
  writeln('                 Mehrschichtiges Neuronales Netz');
  textcolor(lightgray);
  erste:=true;
  buildnet;
  ch:=#0;
  repeat
    gotoxy(1,2);
    writeln;
    n:=setinputs;
    setasolls(n);
    rechnen;
    gotoxy(30,3);
    write('Fehler:',abs(asoll[1]-a[1].a):7:4);
    gotoxy(30,4);
    if asoll[1]<>0 then write('      =',abs(asoll[1]-a[1].a)/asoll[1]:7:4,'%      ');
    if fehler=0 then fehler:=abs(asoll[1]-a[1].a);
    fehler:=(fehler*139+abs(asoll[1]-a[1].a))/140;
    gotoxy(50,3);
    write('Durchschnitt:',fehler:7:4);
    gotoxy(50,4);
    write('            =',fehler:7:4,'%      ');
    gotoxy(1,3);
    for i:=1 to INNUM do begin
      writeln('E',i,'=',input[i]:7:4);
    end;
    for i:=1 to ANUM do begin
      writeln('Asoll',i,'=',asoll[i]:7:4);
    end;
    if n=0 then grafik(1) else grafik(n);
    for i:=1 to ANUM do begin
      writeln('A',i,'=',a[i].a:7:4);
    end;
    for i:=1 to INNUM do begin
      for j:=1 to ZNUM do begin
        gotoxy(60,3+i*ZNUM+j);
        write('E',i,'_Z',j,':',z[1,j].w[i]:7:4);
      end;
    end;
    for i:=1 to ZNUM do begin
      gotoxy(60,9+i);
      write('Z',i,'_A1:',a[1].w[i]:7:4);
    end;
    gotoxy(1,7);
    writeln('lerne...');
    lern(n);
    rechnen;
    for i:=1 to ANUM do begin
      writeln('A',i,'=',a[i].a:7:4);
    end;
    writeln;
    textcolor(1);write('0,0','  A=',grfa[1]:4:4);
    textcolor(lightgray);writeln('                 eta   = ',eta:4:4);
    textcolor(3);write('1,0','  A=',grfa[3]:4:4);
    textcolor(lightgray);writeln('                 alpha = ',alpha:8:10);
    textcolor(5);write('0,1','  A=',grfa[5]:4:4);
    textcolor(lightgray);writeln;
    textcolor(7);write('1,1','  A=',grfa[7]:4:4);
    writeln;
    textcolor(lightgray);
    writeln('Beenden mit ESC.');
    if keypressed then ch:=readkey;
    erste:=false;
  until ch=#27;
  closegraph;
end.